class Management::StatisticsController < ManagementController

  before_action :set_statistics
  before_action :authenticate_user!, except: [:index, :show, :like]

  def index
    @n_users = @@n_users
    @n_collections = @@n_collections
    @n_non_visualised = @@n_non_visualised
    @n_learning_objects = @@n_learning_objects
    @n_complaints = @@n_complaints
    @total_accesses= User.sum("sign_in_count")
  end

  def users
    @n_users = User.count
    @n_curators = Role.find_by(name: "curator").users.size
    @n_admins = Role.find_by(name: "admin").users.size
    @n_teachers = Role.find_by(name: "teacher").users.size
  end

  def accesses
    @total_accesses= User.sum("sign_in_count")
  end

  def collections
    @n_collections ||= @@n_collections
    @collections_most_visualised = @@collections_most_visualised
    @n_collections_non_visualised = @@n_collections_non_visualised
  end


  def learning_objects
    @n_learning_objects = @@n_learning_objects
    @most_visualised = @@most_visualised
    @n_non_visualised = @@n_non_visualised

  end

  def complaints
    @complaints = @@complaints
    @n_complaints = @@n_complaints
    @complaints_objs = @@complaints_objs
    @complaints_per_message = @@complaints_per_message
  end


  def set_statistics
      @@complaints = Complaint.all
      @@n_users = User.count
      @@n_collections = Collection.all.size
      @@collections_most_visualised = Collection.order(:views_count)
      @@n_collections_non_visualised = Collection.where(views_count: 0).size
      @@n_learning_objects = LearningObject.all.size
      @@n_non_visualised = LearningObject.where(views_count: 0).size
      @@most_visualised = LearningObject.order(:views_count)
      @@n_views = LearningObject.sum(:views_count)
      @@n_complaints = Complaint.all.size
      @@complaints_per_message = Complaint.group(:complaint_reason_id).count
      @@complaints_objs = @@complaints.map{|complaint| complaint.complaintable.name}.inject(Hash.new(0)) { |h,e| h[e] += 1; h }
   end

end
